<?php
namespace Claromentis\Core\ORM\Behaviors;

$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"] ?: array()) + array("_7f628626dd1d55c71b1f" . "c0932ffd1d2c" => base64_decode("aXNfYXJyYXk" . "="), "_b255ebafd5b8" . "bb45110cd2db0" . "604fa44" => base64_decode("bWV0YWRhd" . "GE="), "_d5aab080ef90d0e0aeec9b" . "29c03836f2" => base64_decode("TWV0YWRhdGEgbXVzdCBiZSBhbiBhcnJheS" . "BvZiBtZXRhZGF0YSB2YWx1ZXMgb3IgYW4g" . "aW5zdGFuY2Ugb2Yg"), "_c006f837e2824506391e3088e0b02" . "cea" => base64_decode("IG" . "9y" . "IA" . "=="));
use Analogue\ORM\EntityCollection;
use Analogue\ORM\Mappable;
use Illuminate\Support\Collection;
use ProxyManager\Proxy\ProxyInterface;
use Claromentis\Core\ORM\Entity\Metadata as MetadataEntity;






















trait Metadata
{
    
    
    
    
    
    
    protected $metadata;
    
    
    
    
    
    
    public abstract function getMetadataAggregation() : int;
    
    
    
    
    
    
    public function getMetadataObjectId() : int
    {
        return $this->id;
    }
    
    
    
    
    
    
    public function getMetadataSetId() : int
    {
        return 0;
    }
    
    
    
    
    
    
    
    
    
    
    public function getMetadataAttribute($elements) : MetadataEntity
    {
        
        
        if (!$this->metadata) {
            $aggregation = $this->getMetadataAggregation();
            $object_id = $this->getMetadataObjectId();
            $set_id = $this->getMetadataSetId();
            $this->metadata = new MetadataEntity($this, $aggregation, $object_id, $set_id);
            $this->metadata->elements = $elements ?: new EntityCollection();
        }
        return $this->metadata;
    }
    
    
    
    
    
    
    
    
    
    public function setMetadataAttribute($metadata)
    {
        if (!$metadata instanceof MetadataEntity && !$metadata instanceof Collection && !$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_7f628626dd1d55c71b1fc" . "0932ffd1d2c"]($metadata)) {
            throw new \InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_d5aab080ef90d0e0aeec9b2" . "9c03836f2"] . Collection::class . $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_c006f837e2824506391e3088e" . "0b02cea"] . MetadataEntity::class);
        }
        
        
        if ($metadata instanceof MetadataEntity) {
            $this->attributes[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_b255eba" . "fd5b8bb4" . "5110cd2d" . "b0604fa4" . "4"]] = $metadata->getElements()->flatten()->filter();
        }
        if ($metadata instanceof Collection) {
            $this->attributes[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_b255ebafd5b8bb45" . "110cd2db0604fa44"]] = $metadata->flatten()->filter();
        }
        
        
        if ($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_7f628626dd1" . "d55c71b1fc09" . "32ffd1d2c"]($metadata)) {
            $metadataEntity = $this->getMetadataAttribute(null);
            $metadataEntity->setValues($metadata);
        }
    }
}